abuild.in 45.2 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
8
# Depends on: busybox utilities, fakeroot
Natanael Copa's avatar
Natanael Copa committed
9 10
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
55 56 57 58 59 60 61
fi

# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
62 63 64

# functions
msg() {
65
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
66 67 68
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
69 70 71 72 73 74 75
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
76 77 78 79 80 81
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
82 83 84 85 86 87
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
88 89 90 91 92 93
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
95
	logcmd "ERROR: $pkgname: $1"
96 97 98 99 100
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
101
}
Natanael Copa's avatar
Natanael Copa committed
102

Linux User's avatar
Linux User committed
103
set_xterm_title() {
104
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
105
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
106 107 108 109 110
	fi
} 

cleanup() {
	set_xterm_title ""
111
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
112
		msg "Uninstalling dependencies..."
113
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
114
	fi
115 116 117
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
118 119
}

Natanael Copa's avatar
Natanael Copa committed
120
die() {
Linux User's avatar
Linux User committed
121
	error "$@"
Linux User's avatar
Linux User committed
122
	cleanup
Natanael Copa's avatar
Natanael Copa committed
123 124 125
	exit 1
}

126
# check if apkbuild is basicly sane
127
default_sanitycheck() {
128
	local i= j= suggestion=
129
	msg "Checking sanity of $APKBUILD..."
130 131 132
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
133
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
134
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
135 136
			die "$pkgver is not a valid version"
	fi
137
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
138 139 140
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
Natanael Copa's avatar
Natanael Copa committed
141 142 143
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
144

Natanael Copa's avatar
Natanael Copa committed
145 146
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
147 148
		die "replaces_priority must be a number"
	fi
149 150 151 152 153 154 155
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

156 157 158 159 160 161 162 163 164 165
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
166
	for i in $install; do
167
		local n=${i%.*}
168
		local suff=${i##*.}
169 170 171 172 173
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
174
			die "$i: install script does not match pkgname or any subpackage"
175
		fi
176
		[ -e "$startdir/$i" ] || die "install script $i is missing"
177 178 179 180 181 182
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
183 184
	done
	
185 186 187 188 189 190 191 192
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
193

194 195
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
196 197
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
198 199 200 201
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
Natanael Copa's avatar
Natanael Copa committed
202
			case "$i" in
203
				*::*) i=${i%%::*};;
204
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
205
			esac
206 207
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
208 209
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
210

211 212 213 214 215 216 217 218
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
219
		done
220
	done
221

222 223 224
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
225 226

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
227 228

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
229 230 231
	return 0
}

232 233 234 235
sanitycheck() {
	default_sanitycheck
}

236 237
sumcheck() {
	local algo="$1" sums="$2"
238
	local dummy f endreturnval originalparams origin file
239 240 241 242 243 244 245 246

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
247
	fi
248
	fetch || return 1
249
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
250
	cd "$srcdir" || return 1
251 252
	IFS=$'\n'
	endreturnval=0
253
	for src in $sums; do
254
		origin=$1; shift
255
		echo "$src" | ${algo}sum -c
256
		if [ $? -ne 0 ]; then
257
			endreturnval=1
258
			is_remote $origin || continue
259
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
260 261 262 263 264 265 266 267
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
268 269
}

270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
294 295
# verify upstream sources
sourcecheck() {
296 297 298 299 300 301 302 303
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
304 305 306
		*::*)
			uri=${uri##*::}
			;;
307 308
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
309
	done
310
	return 0
Natanael Copa's avatar
Natanael Copa committed
311
}
312

313 314 315
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
316
	while getopts "C:Lko:s" opt; do
317
		case $opt in
318
		'L') ;; # --location. wget does this by default
319
		'f') ;; # --fail. wget does this by default
320 321 322 323 324 325 326 327 328 329
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
330 331
uri_fetch() {
	local uri="$1"
332
	local d="${uri##*/}"	# $(basename $uri)
333
	local opts
334
	[ -n "$quiet" ] && opts="-s"
335 336

	local lockfile="$SRCDEST/$d".lock
337

338 339 340 341 342
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
343 344 345 346 347

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
Natanael Copa's avatar
Natanael Copa committed
348
	esac
349 350

	case "$uri" in
351
		https://*) opts="-k";;
352
	esac
353

Natanael Copa's avatar
Natanael Copa committed
354
	mkdir -p "$SRCDEST"
355 356 357

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
358 359
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
360 361 362

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

363 364
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
365
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
366
	fi
Linux User's avatar
Linux User committed
367
	msg "Fetching $uri"
368 369

	# fallback to wget if curl is missing. useful for bootstrapping
370
	local fetcher=
371 372
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
373 374
	else
		fetcher=curl
375
		opts="$opts -L -f -k"
376 377 378
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
379
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
380

381
	) 9>$lockfile
382 383 384 385

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
386 387
}

388
is_remote() {
389
	case "${1#*::}" in
390
		http://*|ftp://*|https://*|saveas-*://*)
391 392 393 394 395
			return 0;;
	esac
	return 1
}

396 397 398 399 400 401 402 403 404
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

405 406 407 408
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
409
		if is_remote "$DISTFILES_MIRROR"; then
410 411
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
412
		else
413 414
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
415
		fi
416 417 418 419
	fi
	uri_fetch "$uri"
}

420
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
421 422
	local s
	mkdir -p "$srcdir"
423 424
	for s in $source; do
		if is_remote "$s"; then
425
			uri_fetch_mirror "$s" || return 1
426
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
427 428 429
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
430 431 432
	done
}

433 434 435 436
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
437 438 439 440 441 442 443 444 445 446 447 448 449 450 451
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
452
# unpack the sources
453
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
454
	local u
455
	if [ -z "$force" ]; then
456
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
457
		initdcheck || return 1
458
	fi
Natanael Copa's avatar
Natanael Copa committed
459 460
	mkdir -p "$srcdir"
	for u in $source; do
461
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
462
		case "$s" in
463 464 465
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
466
			*.tar.gz|*.tgz)
467
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
468 469
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
470
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
471
				tar -C "$srcdir" -jxf "$s" || return 1;;
472 473 474 475
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
476 477 478
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
479 480 481
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
482 483 484 485
		esac
	done
}

486 487 488 489
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
490 491
# cleanup source and package dir
clean() {
492
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
493
	rm -rf "$srcdir"
494
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
495 496 497 498 499 500
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
501
		if is_remote "$s"; then
502 503 504
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
505
		fi
Natanael Copa's avatar
Natanael Copa committed
506 507 508
	done
}

509 510 511 512 513 514 515 516 517 518
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
519 520
cleanpkg() {
	local i
521
	getpkgver || return 1
522
	msg "Cleaning built packages..."
523
	for i in $(listpkgnames); do
524 525
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
526
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
527
	done
528
	# remove given packages from index
529
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
530 531
}

532 533 534
# clean all packages except current
cleanoldpkg() {
	local i j
535
	getpkgver || return 1
536
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
537
	for i in $(listpkgnames); do
538 539 540 541 542
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
543 544 545 546
		done
	done
	return 0
}
547 548 549

mkusers() {
	local i
550 551 552 553 554 555
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
556 557
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
558
			local gopt=
559
			msg "Creating user $i"
560 561 562
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
563
			$ADDUSER -S -D -H $gopt $i || return 1
564 565 566 567 568
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
569 570
runpart() {
	local part=$1
571
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
572 573 574 575
	$part || die "$part failed"
}

# override those in your build script
576 577 578 579 580 581 582 583
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
584 585 586 587
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
588
build() {
589
	:
Natanael Copa's avatar
Natanael Copa committed
590 591
}

592 593 594
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
595
	mkdir -p "$PKGDEST"
596 597 598
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
599 600 601 602 603 604 605 606 607
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

608 609 610
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
611
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
612 613 614 615 616 617 618 619
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
620 621 622 623 624 625 626 627 628 629 630 631 632
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
633 634 635 636 637 638 639 640 641
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
642 643 644 645 646 647 648 649 650
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
651 652 653
	return 0
}

654
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
655 656
	local i
	cd "$startdir"
657
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
658 659
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
660
		msg "Running split function $func..."
661
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
662 663 664
		( subpkgdir="$dir" subpkgname="$name" \
			$0 $func prepare_package \
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
665
	done
666
	postcheck "$pkgdir" "$pkgname" || return 1
667 668
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
669
		warning "Found /usr/share/locale"
670
		warning2 "Maybe add \$pkgname-lang to subpackages?"
671
	fi
Natanael Copa's avatar
Natanael Copa committed
672 673
}

674
default_lang() {
675
	pkgdesc="Languages for package $pkgname"
676 677 678 679 680 681 682 683 684 685 686 687 688
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

689
default_lang_subpkg() {
690 691 692 693
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
694
	pkgdesc="$pkgname language pack for $lang"
695 696
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
697 698 699 700 701
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
702
		|| return 1
703 704 705 706 707
	done
}

lang_subpkg() {
	default_lang_subpkg
708 709 710 711 712 713 714 715 716 717 718
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

719 720 721 722 723 724 725 726 727 728 729 730
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

731 732 733 734 735 736
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

737
prepare_metafiles() {
738
	getpkgver || return 1
739 740
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
741
	local dir=${subpkgdir:-$pkgdir}
742
	local pkg="$name-$pkgver-r$pkgrel.apk"
743
	local pkginfo="$controldir"/.PKGINFO
744
	local sub
Natanael Copa's avatar
Natanael Copa committed
745 746 747
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
748
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
749 750
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
751
	local parch="$CARCH"
752 753 754 755 756

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
757

758
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
759
	if [ -n "$FAKEROOTKEY" ]; then
760
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
761
	fi
762 763
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
764
pkgname = $name
765
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
766 767 768 769 770
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
771
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
772
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
773
EOF
774 775
	local i deps
	deps="$depends"
776
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
777 778
		for i in $install $triggers; do
			local s=${i%=*}
779
			[ "$name" != "${s%.*}" ] && continue
780
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
781 782 783 784 785
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
786 787
	fi
	
788 789 790 791 792 793 794 795 796 797
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

798
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
799
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
800 801
	fi

Natanael Copa's avatar
Natanael Copa committed
802
	for i in $license; do
803
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
804 805
	done
	for i in $replaces; do
806
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
807
	done
808
	for i in $deps; do
809
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
810 811
	done
	for i in $conflicts; do
812
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
813 814
	done
	for i in $provides; do
815
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
816
	done
817 818 819 820 821 822
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
823 824 825
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
826 827

	local metafiles=".PKGINFO"
828 829 830
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
831
		if [ "$n" != "$name" ]; then
832 833
			continue
		fi
834
		script=${f#$name}
835
		msg "Adding $script"
836
		cp "$startdir/$f" "$controldir/$script" || return 1
837
		chmod +x "$controldir/$script"
838 839
		metafiles="$metafiles $script"
	done
840
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
841
}
842

843 844
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
845
	local etype= soname= file= sover=
846
	[ "$arch" = "noarch" ] && return 0
847
	options_has "!tracedeps" && return 0
848
	# lets tell all the places we should look for .so files - all rpaths
849 850
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
851
		>"$controldir"/.rpaths
852 853 854 855 856 857 858
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
859 860
}

861 862 863 864 865 866 867 868 869 870 871 872
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

873 874 875 876 877
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

878 879 880 881 882 883 884
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
885 886 887
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
888 889 890 891
	fi
	return 0
}

892
prepare_package() {
893
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
894
	stripbin
895 896
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
897 898 899 900 901 902 903 904
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

928 929 930 931
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

932 933 934
trace_apk_deps() {
	local name="$1"
	local dir="$2"
935
	local i= found= autodeps= deppkgs= missing=
936
	msg "Tracing dependencies..."
937 938 939
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
940
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
941 942 943 944
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
945
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
946 947
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
948
		msg "  added libgcc (due to libpthread)"
949
	fi
950
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
951 952 953 954 955
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

		if subpkg_provides "$i" || $APK info -q -e "so:$i"; then
			autodeps="$autodeps so:$i"
956
		else
957
			missing="$missing $i"
958
		fi
959 960 961
	done

	# find all packages that holds the so files
962
	if [ -f "$dir"/.rpaths ]; then
963 964
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
965 966 967
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

968
	for found in $deppkgs; do
969
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
970 971 972
			warning "You can remove '$found' from depends"
			continue
		fi
973
		autodeps="$autodeps $found"
974
	done
975

976
	echo "# automatically detected:" >> "$dir"/.PKGINFO
977
	if [ -f "$dir"/.provides-so ]; then
978
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
979
			>> "$dir"/.PKGINFO
980 981
	fi
	[ -z "$autodeps" ] && return 0
982
	for i in $autodeps; do
983 984
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
985 986
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
987 988
}

989
find_scanelf_paths() {
990
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
991
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
992
	if [ -n "$ldpath" ]; then
993
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
994 995
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
996 997
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
998
		while read i; do
999 1000 1001 1002
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
1003
			fi
1004
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
1005
		done < "$rpaths"
1006 1007 1008 1009 1010 1011
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
1012
	local opt=
1013 1014 1015

	# allow spaces in paths
	IFS=:
1016
	set -- $(find_scanelf_paths "$datadir")
1017 1018
	unset IFS

1019 1020 1021
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
1022 1023
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
1024
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
1025 1026
		# if soname field is missing, soname will be the filepath
		sover=0
1027 1028
		if [ -z "$file" ]; then
			file="$soname"
1029
			soname=${soname##*/}
1030 1031 1032 1033
		fi

		# we only want shared libs
		case $soname in
1034
		*.so|*.so.[0-9]*|*.c32);;
1035 1036 1037 1038 1039 1040 1041 1042 1043
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1044 1045 1046 1047
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1048 1049 1050
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1051
		list_has "$soname" $somask && continue
1052
		echo "$soname $sover"
1053 1054 1055 1056 1057 1058 1059 1060 1061 1062
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1063 1064 1065 1066 1067

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1068
	| while read soname; do
1069
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1070 1071 1072
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1073 1074 1075
	done > "$controldir"/.needs-so
}

1076 1077 1078 1079 1080 1081 1082 1083
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1084
create_apks() {
1085
	local file= dir= name= ver= apk= datadir= size=
1086
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1087
	mkdir -p "$PKGDEST"
1088 1089 1090 1091 1092 1093 1094 1095 1096
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1097
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1098 1099 1100
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1101
		size=$(pkginfo_val size $file | human_size)
1102 1103 1104
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1105 1106

		trace_apk_deps "$name" "$dir" || return 1
1107
		msg "Package size: ${size}"
1108
		msg "Compressing data..."
1109
		(
1110 1111
		cd "$datadir"
		# data.tar.gz
1112 1113 1114 1115 1116 1117
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1118

1119
		msg "Create checksum..."
1120 1121 1122 1123 1124
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1125
		cd "$dir"
1126 1127
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1128
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1129

1130
		msg "Create $apk"
1131 1132
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1133
		)
1134
	done
1135
	subpkgname=
1136 1137
}

1138
clean_abuildrepo() {
1139
	local apk
1140 1141 1142
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
1143
	for